<script setup>
import { onUnmounted, ref } from "vue";

const props = defineProps({ data: Object });

const hungry = ref(props.data.hungry || 0);
const src = ref(props.data.src);

const interval = setInterval(() => {
  hungry.value += 1;
  if (hungry.value >= 20) {
    src.value = "/dead.png";
  }
}, 2000);
onUnmounted(() => clearInterval(interval));

const feed = () => {
  hungry.value = 0;
};
</script>

<template>
  <div
    class="fish"
    :style="{ top: data.y + 'px', aleft: data.x + 'px' }"
    @click="feed"
    v-if="hungry < 30"
  >
    <img :src="src" :alt="data.name" class="fish__img" />
    <span class="fish__name">{{ data.name }}</span>
    <button class="fish__alert" v-if="hungry > 10 && hungry < 20">
      Feed me
    </button>
  </div>
</template>

<style scoped>
@-webkit-keyframes swim {
  0% {
    margin-left: 0px;
    -webkit-transform: scaleX(1);
    transform: scaleX(1);
  }
  50% {
    margin-left: 80%;
  }
  100% {
    margin-left: 0px;
    -webkit-transform: scaleX(-1);
    transform: scaleX(-1);
  }
}

@keyframes swim {
  0% {
    margin-left: 0px;
  }
  50% {
    margin-left: 80%;
  }
  100% {
    margin-left: 0px;
  }
}

@keyframes flip {
  0% {
    transform: scaleX(1);
  }
  50% {
    transform: scaleX(1);
  }
  55% {
    transform: scaleX(-1);
  }
  97% {
    transform: scaleX(-1);
  }
}

@-moz-keyframes bounce {
  0%,
  50%,
  100% {
    -moz-transform: translateY(0);
    transform: translateY(0);
  }
  25% {
    -moz-transform: translateY(-5px);
    transform: translateY(-5px);
  }
  75% {
    -moz-transform: translateY(-3px);
    transform: translateY(-3px);
  }
}
@-webkit-keyframes bounce {
  0%,
  50%,
  100% {
    -webkit-transform: translateY(0);
    transform: translateY(0);
  }
  25% {
    -webkit-transform: translateY(-5px);
    transform: translateY(-5px);
  }
  75% {
    -webkit-transform: translateY(-3px);
    transform: translateY(-3px);
  }
}
@keyframes bounce {
  0%,
  50%,
  100% {
    -moz-transform: translateY(0);
    -ms-transform: translateY(0);
    -webkit-transform: translateY(0);
    transform: translateY(0);
  }
  25% {
    -moz-transform: translateY(-5px);
    -ms-transform: translateY(-5px);
    -webkit-transform: translateY(-5px);
    transform: translateY(-5px);
  }
  75% {
    -moz-transform: translateY(-3px);
    -ms-transform: translateY(-3px);
    -webkit-transform: translateY(-3px);
    transform: translateY(-3px);
  }
}

.fish {
  position: absolute;
  text-align: center;
  -moz-animation:
    swim 20s,
    bounce 2s infinite;
  -webkit-animation:
    swim 20s,
    bounce 2s infinite;
  animation:
    bounce 2s infinite,
    swim 20s infinite;
  animation-timing-function: linear;
  -webkit-animation-timing-function: linear;
}

.fish__img {
  height: 90px;
  animation: flip 20s infinite;
}
.fish__name {
  @apply bg-blue-100 border-t border-b border-blue-500 text-blue-700 px-3 py-2;
}
.fish__alert {
  @apply bg-red-500 text-white font-bold rounded-t px-4 py-2;
  display: block;
  margin: 0 auto;
}
</style>
